import c4d

from texpath import ids
from texpath.maindialog import MainDialog    


# this class is the basic plugin
class CMDData(c4d.plugins.CommandData):
    
    __dialog = None

    # we could also just execute some code here - the dialog is optional 
    def Execute(self, doc):
        
        
        x= (c4d.gui.GeGetScreenDimensions(1,1,False)['sx2'] / 2) - ids.DW/2
        y= (c4d.gui.GeGetScreenDimensions(1,1,False)['sy2'] / 2) - ids.DH/2  
        
    
        # create a maindialog object if it hasn't been initialized jet
        if self.__dialog is None:            
            self.__dialog = MainDialog()

        # return the successful opening of the dialog
        return self.__dialog.Open(c4d.DLG_TYPE_ASYNC, ids.PLUGINID, defaultw=ids.DW, defaulth=ids.DH, xpos=x, ypos=y)
    
        
    # needed to restore minimized dialogs and for startup layout integration
    def RestoreLayout(self, sec_ref):
    
        # create a maindialog object if it hasn't been initialized jet
        if self.__dialog is None:            
            self.__dialog = MainDialog()

        # return the successful restauration of the dialog
        return self.__dialog.Restore(ids.PLUGINID, sec_ref)